#ifndef SPARROWBOT_H
#define SPARROWBOT_H

#include "user.h"
#include "message.h"
#include <QObject>

class SparrowBot : public QObject
{
    Q_OBJECT

    enum{OFFLINE, ONLINE, ON_CHAN};

    QString nick;
    QString chan;
    int status;
    UserList users;

public:
    SparrowBot(QString nick_, QString chan_) : nick(nick_), chan(chan_), status(OFFLINE) {}

private:
    void handleMessage(Message msg);

    // IRC commands
    QString pong(QString target);
    QString join(QString theChan);
    QString privateSay(QString str, QString target);
    QString whois(QString nick);
    QString say(QString str);
    QString action(QString str);
    QString quit(QString str);

public slots:
    void receiveMsg(QString msg);
    void disconnect();

signals:
    void sendMsg(QString msg);
};

#endif // SPARROWBOT_H
